module Rakka.Resource.DumpRepos
    ( resDumpRepos
    )
    where

import           Control.Monad.Trans
import           Network.HTTP.Lucu
import           Rakka.Environment
import           Subversion.Repository

resDumpRepos :: Environment -> ResourceDef
resDumpRepos env
    = ResourceDef {
        resUsesNativeThread = False
      , resIsGreedy         = False
      , resGet              = Just $ dumpRepos $ envRepository env
      , resHead             = Nothing
      , resPost             = Nothing
      , resPut              = Nothing
      , resDelete           = Nothing
      }


dumpRepos :: Repository -> Resource ()
dumpRepos repos
    = do setContentType $ read "application/octet-stream"
         -- FIXME: 最終更新時刻が判るはず。
         dump <- liftIO $ dumpRepository repos Nothing Nothing False True
         outputLBS dump
